/*******************************************************************************/
/*                                                                             */
/*    Copyright (c) 2007 Analog Devices, Inc.  All Rights Reserved.            */
/*    This software is proprietary to Analog Devices, Inc. and its 			   */
/*	  licensors.                                  							   */
/*                                                                             */
/*    CHANGES:  07/02/2007  1.00  - initial public release  				   */
/*																			   */
/*******************************************************************************/

/*********************************************************************

Include files

*********************************************************************/

//ISRS
#include "main.h"
#include "stdio.h"
#include "system.h"

static unsigned int counter_ppi_rx =0;
static unsigned int counter_ppi_tx =0;
static unsigned int counter_mdma1_0 =0;
static unsigned int counter_sport_rx =0;

EX_INTERRUPT_HANDLER(CORE_TIMER)
{
	long long int t_throughput = 0;
	
	#ifdef PPI0
		//Disable PPI DMA
		DisablePPI0();
	#endif
	
	#ifdef PPI1
		//DisablePPI1();
	#endif
	
	//Disable MEMDMA 1 and 2
	#ifdef MEMDMA1_0
		*pMDMA1_S0_CONFIG &=  0x0;									// ENABLE MDMA
		ssync();
		*pMDMA1_D0_CONFIG &=  0x0;
		ssync();
	#endif
	
	#ifdef MEMDMA1_1
		*pMDMA1_S1_CONFIG &=  0x0;									// ENABLE MDMA
		ssync();
		*pMDMA1_D1_CONFIG &=  0x0;
		ssync();
	#endif
	
	#ifdef MEMDMA2_0
		*pMDMA2_S0_CONFIG &=  0x0;									// ENABLE MDMA
		ssync();
		*pMDMA2_D0_CONFIG &=  0x0;
		ssync();
	#endif
	
	#ifdef MEMDMA2_1
		*pMDMA2_S1_CONFIG &=  0x0;									// ENABLE MDMA
		ssync();
		*pMDMA2_D1_CONFIG &=  0x0;
		ssync();
	#endif
	
	//Disable SPORTS
	#ifdef SPORT0_RECV
		Disable_Sport0();
	#endif
	
	#ifdef SPORT1_TRMT
		Disable_Sport1();
	#endif
	
    printf("\n Total PPI frames Rx %d,Tx %d \n", counter_ppi_rx,counter_ppi_tx);
    printf("\n Total MDMA1_0 transfers %d \n",counter_mdma1_0);
    printf("\n Total SPORT transfers %d \n",counter_sport_rx);
    t_throughput = (counter_ppi_rx+counter_ppi_tx)*1716*525 + counter_mdma1_0*BUFFER_SIZE + counter_sport_rx*SPORT_BUFFER_SIZE;//BUFFER_SIZE;
    printf("\n Total throughput\n");
    printf("\n Total throughput : %d MB/s\n",t_throughput);
	while(1);

}
//DMA isr routine
EX_INTERRUPT_HANDLER(PPI_TxIsr)
{
	int i;
	int status = *pSICA_ISR0;
	int temp = status&0x00001000;
	if(temp==0x00001000)
	{
		*pDMA1_1_IRQ_STATUS |= DMA_DONE;		// acknowledge interrupt	
		counter_ppi_tx++;
	}
	
	temp = status&0x00000800;
	if(temp==0x00000800)
	{
		*pDMA1_0_IRQ_STATUS |= DMA_DONE;		// acknowledge interrupt
		counter_ppi_rx++;
	}
}

EX_INTERRUPT_HANDLER(MDMA_Isr)
{
	*pMDMA1_D0_IRQ_STATUS |= DMA_DONE;
	counter_mdma1_0++;
	
	*pMDMA1_D1_IRQ_STATUS |= DMA_DONE;
	*pMDMA2_D0_IRQ_STATUS |= DMA_DONE;
	*pMDMA2_D1_IRQ_STATUS |= DMA_DONE;
	//MDMA_Ready=true;
}

EX_INTERRUPT_HANDLER(Sport_Isr)
{
	*pDMA2_2_IRQ_STATUS |= DMA_DONE;
	counter_sport_rx++;
	*pDMA2_3_IRQ_STATUS |= DMA_DONE;
    
}
EX_INTERRUPT_HANDLER(PPI_ErrIsr)
{
	while(1);
}

EX_EXCEPTION_HANDLER(ex_handler) {
	while(1);
}

EX_EXCEPTION_HANDLER(EXCEPTION_HANDLER) {
	while(1);
}

EX_HARDWARE_HANDLER(HARDWARE_HANDLER) {
	while(1);
}
