/*******************************************************************************/
/*                                                                             */
/*    Copyright (c) 2007 Analog Devices, Inc.  All Rights Reserved.            */
/*    This software is proprietary to Analog Devices, Inc. and its 			   */
/*	  licensors.                                  							   */
/*                                                                             */
/*    CHANGES:  07/02/2007  1.00  - initial public release  				   */
/*																			   */
/*******************************************************************************/

#include "cdefBF561.h"
#include "ccblkfn.h"
#include <sys\exception.h>
#include "sysreg.h"

#define pFlashA_PortA_Dir	((volatile unsigned short *)0x20270006)
#define pFlashB_PortA_In	((volatile unsigned char *)0x202E0000)	// address of flash B port A input data register
#define pFlashB_PortA_Out	((volatile unsigned char *)0x202E0004)	// address of flash B port A output data register
#define pFlashB_PortA_Dir	((volatile unsigned char *)0x202E0006)	// address of flash B port A direction register

#define RST_7183 				(0x8) 	    //decoder reset bit #3 in flashA portA
#define PPICLK_ADV7183_SELECT 	(0x10)		//decoder clock to PPI bit #4 in flashA portA
#define ADV7183_OE 				(0x4)		//ADV7183 /OE = PF2

#define pFlashA_PortA_Out	((volatile unsigned char *)0x20270004)	// address of flash A port A output data register
#define RST_7171 				(0x4)  // encoder reset

//descriptor declarations
struct sDMA_descriptor {struct sDMA_descriptor* next_descriptor;
					    char *start_address;
};
typedef struct sDMA_descriptor tDMA_descriptor;


extern tDMA_descriptor DMA_PPI_first;


//prototype functions
void InitSDRAM(void);
void InitInterrupts(void);
void EnableVideoEncoder(void);
void EnableVideoDecoder(void);
void InitPPI1(bool pack32, tDMA_descriptor* First_Header, short pixel, short lines);
void InitPPI0(bool entire_field, bool pack32, tDMA_descriptor* First_Header, short pixel, short lines);

void EnablePPI1(void);
void EnablePPI0(void);
void DisablePPI0(void);
void DisablePPI1(void);
void Init_PPI_DMA(tDMA_descriptor*);

void InitMDMA1_CH0(char * buffer1, char * L1bufferA);
void InitMDMA1_CH1(char * buffer1, char * L1bufferA);
void InitMDMA2_CH0(char * buffer1, char * L1bufferA);
void InitMDMA2_CH1(char * buffer1, char * L1bufferA);

void Reset_ADV7179(void );
void Reset_ADV7183(void );
void Init1836(void);
void Init_PLL(void);
void Set_PLL(short CoreCLOCK_multiplier, short SCLK_divider);

/**********video_out.h*******************/
int 			NtscVideoOutFrameBuffInit 	( char *base_address );
void 			Write_To_Frame				( unsigned short X, unsigned short Y, unsigned int val, void * buffer );
unsigned int 	Read_From_Frame				(unsigned short X, unsigned short Y, void *buffer );

void 			FillFrame 					(char *Frame, int Value);
#define ENTIRE_FIELD_MODE		// comment out for Active Field only
#define NTSC_NUM_LINES (525)
#define PIXEL_PER_LINE 	(858)
/**************************************/

EX_INTERRUPT_HANDLER(PPI0_RxIsr);
EX_INTERRUPT_HANDLER(PPI_TxIsr);
EX_INTERRUPT_HANDLER(PPI_ErrIsr);
EX_INTERRUPT_HANDLER(MDMA_Isr);
EX_INTERRUPT_HANDLER(Sport_Isr);
EX_INTERRUPT_HANDLER(CORE_TIMER);
//EX_INTERRUPT_HANDLER(EXCEPTION_HANDLER);
//EX_INTERRUPT_HANDLER(HARDWARE_HANDLER);
